from . import models
class Modeler(object):
    """docstring for Modeler."""
    def __init__(self):
        super(Modeler, self).__init__()

    def loadMap(self,mapName,message):
        map = models.models[mapName]
        return self._hexaval_byte_mapper(map,message)

    def _calcMHDR(self,data):
        retStruct = {}
        mhdr = format(int(data, 16), "08b")
        retStruct['MHDR'] = data
        MType = mhdr[0:3]
        MTypes = {
             "000":"Join Request",
             "001":"Join Accept",
             "010":"Unconfirmed Data Up",
             "011":"Unconfirmed Data Down",
             "100":"Confirmed Data Up",
             "101":"Confirmed Data Down",
             "110":"RFU",
             "111":"Proprietary",
        }
        try:
            retStruct['MType'] = MTypes[MType]
            return retStruct
        except Exception as e:
            retStruct['MType'] = "Unknown"
            return retStruct

    def _hexaval_byte_mapper(self,template,message):
        hexval = message
        posCounter=0
        fields=template['fields']
        outDict = {}
        outDict['Message'] = message
        outDict['MHDR'] = {}
        outDict['MIC'] = ""
        outDict['Payload'] = ""
        outDict['MACPayload'] = {}
        for item in fields:
            for fname in item:
                if fname == "MHDR" and item[fname] == "MHDR":
                    outDict['MHDR'] = self._calcMHDR(hexval[posCounter:2])
                    posCounter += 2
                elif fname == "MIC" and item[fname] == "MIC":
                    #val = hexval[posCounter:posCounter + 8]
                    val = hexval[-8:]
                    hexval =  hexval[:-8]
                    if val == "":
                        outDict['MIC'] = "Unknown"
                    else:
                        outDict['MIC'] = val
                    #posCounter += 8
                elif item[fname] == "-":
                    outDict['Payload'] += hexval[posCounter:]
                    outDict['MACPayload'][fname] = hexval[posCounter:]
                    posCounter += len(hexval[posCounter:])
                else:
                    leng  = item[fname] * 2
                    value = hexval[posCounter:posCounter + leng]
                    posCounter += leng
                    outDict['Payload'] += value
                    outDict['MACPayload'][fname] = value
        return outDict
