from . import mic,util,crypton
from . import models
import copy

def decryptJoinAccept(AppKey="",JoinRequestDevNonce="",Payload=""):
    '''Decodes JoinAccept message'''
    hexPayloadList = "".join(util.hexString2hexList(Payload)[1:])
    decriptedMessage = crypton.encryptAES_ECB(AppKey,hexPayloadList,padding=16)
    decriptedMessage = "".join(util.hexString2hexList(decriptedMessage)[0:32]) #We emulate 16 bytes 0's IV vector
    return decriptedMessage.upper()

def genSessionKeys(AppKey="",JoinRequestDevNonce="",Payload=""):
    '''Generates the NwkSKey and AppSKey'''
    devNonce = util.msb2lsb(JoinRequestDevNonce)
    decrypted_joinAccept = "20"  + decryptJoinAccept(AppKey=AppKey,JoinRequestDevNonce=JoinRequestDevNonce,Payload=Payload)
    model_handler = models.Modeler.Modeler()
    outModel = model_handler.loadMap("JoinAccept",decrypted_joinAccept)
    sKey = outModel['MACPayload']['AppNonce'] + outModel['MACPayload']['NetID'] + devNonce + "00000000000000"
    nwkSKey = crypton.encryptAES_ECB(AppKey, "01" + sKey)
    appSKey = crypton.encryptAES_ECB(AppKey, "02" + sKey)
    outModel['nwkSKey'] = nwkSKey
    outModel['appSKey'] = appSKey
    outModel['MACPayload']['DevAddr'] = util.msb2lsb(outModel['MACPayload']['DevAddr'])
    outModel['MACPayload']['AppNonce'] = util.msb2lsb(outModel['MACPayload']['AppNonce'])
    outModel['MACPayload']['NetID'] = util.msb2lsb(outModel['MACPayload']['NetID'])
    return outModel

def decryptDownLink(AppSKey="",NwkSKey="",Payload=""):
    '''Decrypts lorawan downlink message'''
    model_handler = models.Modeler.Modeler()
    outModel = model_handler.loadMap("DownLink",Payload)
    #We compose the model
    defaultSchema = models.models.frameModels['FrameDef']
    encoded = copy.deepcopy( models.models.frameModels['FrameDef'])
    encoded['MHDR']['MType'] = outModel['MHDR']['MType']
    encoded['MACPayload']['FHDR']['DevAddr'] = outModel['MACPayload']['DevAddr']
    encoded['MACPayload']['FHDR']['FCtrl'] =  outModel['MACPayload']['FCtrl']
    encoded['MACPayload']['FHDR']['FCnt'] =  outModel['MACPayload']['FCnt']
    encoded['MACPayload']['FPort'] =  outModel['MACPayload']['FPort']
    encoded['MACPayload']['FRMPayload'] =  outModel['MACPayload']['FRMPayload']

    # Now we decrypt
    port = 1
    if  outModel['MACPayload']['FPort'] == '00':
        port=0
    decoded = crypton.encryptMACPayload(NwkSKey,AppSKey,{ "schema": encoded, "FPort": port },'down')
    return  decoded

def decryptDownLinkUtf(AppSKey="",NwkSKey="",Payload=""):
    '''Decrypts lorawan downlink message in utf format'''
    decrypted = decryptDownLink(AppSKey=AppSKey,NwkSKey=NwkSKey,Payload=util.base642hexString(Payload))
    return util.hexString2text(decrypted)
