import base64,binascii,random
import struct
# @author Alpeza

#--- Bytes Handling -----
def msb2lsb(hexstring):
    ''' Converts msb hex string in lsb hex string '''
    tmplist=hexString2hexList(hexstring)
    tmplist.reverse()
    return "".join(tmplist)

def genRandomBytes(size):
    ''' Generates random bytes coded as HEX String
    @size Number of random bytes
    '''
    ran=bytearray(random.getrandbits(8) for _ in range(size))
    return binascii.b2a_hex(ran).decode("utf-8")

def hexString2hexList(hexstring):
    ''' Converts hexString in a hex byte List '''
    tmplist=[]
    for i in range(0,len(hexstring),2):
        tmplist.append(hexstring[i:i+2])
    return tmplist

def base642hexString(base64message):
    return binascii.b2a_hex(binascii.a2b_base64(base64message)).decode("utf-8").upper()

def text2hexString(text):
    '''Convers a text string in a HexString '''
    return binascii.b2a_hex(binascii.a2b_qp(text.encode('utf-8'))).decode("utf-8").upper()

def integer22hexString(number):
    #2 bytes
    return binascii.b2a_hex(struct.pack(">H", number)).decode("utf-8").upper()

def integer21hexString(number):
    #1 byte
    return binascii.b2a_hex(struct.pack(">H", number)).decode("utf-8").upper()[2:]

def hexString2text(hexstring):
    try:
        return binascii.a2b_hex(hexstring).decode("utf-8")
    except Exception as e:
        return None

def bitString2hexString(bitString,pad=''):
    ''' Convers a bit String in a hex String '''
    #pad='%08X'
    if pad == '':
        return '%X' % int(bitString, 2)
    else:
        return pad % int(bitString, 2)
def hexStringXOR(firstHexString,secondHexString):
    a = hexString2hexList(firstHexString)
    b = hexString2hexList(secondHexString)
    result = ''
    for i in range(len(b)):
        ai = int.from_bytes(binascii.a2b_hex(a[i]),"big")
        bi = int.from_bytes(binascii.a2b_hex(b[i]),"big")
        bitwise = integer21hexString(ai ^ bi)
        result += bitwise
    return result

#--- Schema Handling -----
def serialize(schemaSection):
    ret = ''
    for key in schemaSection:
        ret += schemaSection[key]
    return ret

def ifExists(field,structure,default):
    ''' Checks if exists a field in structure '''
    fieldArray = field.split('.')
    value = default
    tmp={}
    if len(fieldArray):
        if fieldArray[0] in structure:
            value = structure[fieldArray[0]]
        else:
            return default
    for i in range(len(fieldArray) - 1 ):
        try:
            if fieldArray[i + 1] in structure[fieldArray[i]]:
                value = structure[fieldArray[i]][fieldArray[i + 1]]
                tmp[fieldArray[i + 1]] = value
                structure = tmp
            else:
                value = default
                break
        except Exception as e:
            return default
    return value
